# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_certificateexport`](#dsc_certificateexport): The DSC CertificateExport resource type. Automatically generated from version 6.0.0
* [`dsc_certificateimport`](#dsc_certificateimport): The DSC CertificateImport resource type. Automatically generated from version 6.0.0
* [`dsc_certreq`](#dsc_certreq): The DSC CertReq resource type. Automatically generated from version 6.0.0
* [`dsc_pfximport`](#dsc_pfximport): The DSC PfxImport resource type. Automatically generated from version 6.0.0
* [`dsc_waitforcertificateservices`](#dsc_waitforcertificateservices): The DSC WaitForCertificateServices resource type. Automatically generated from version 6.0.0

## Resource types

### <a name="dsc_certificateexport"></a>`dsc_certificateexport`

The DSC CertificateExport resource type.
Automatically generated from version 6.0.0

#### Properties

The following properties are available in the `dsc_certificateexport` type.

##### `dsc_allowexpired`

Data type: `Optional[Boolean]`

Allow an expired certificate to be exported. Certificate selector parameter.

##### `dsc_chainoption`

Data type: `Optional[Enum['BuildChain', 'buildchain', 'EndEntityCertOnly', 'endentitycertonly']]`

Specifies the options for building a chain when exporting a PFX certificate.

##### `dsc_dnsname`

Data type: `Optional[Array[String]]`

The subject alternative name of the certificate to export must contain these values. Certificate selector parameter.

##### `dsc_enhancedkeyusage`

Data type: `Optional[Array[String]]`

The enhanced key usage of the certificate to export must contain these values. Certificate selector parameter.

##### `dsc_friendlyname`

Data type: `Optional[String]`

The friendly name of the certificate to export. Certificate selector parameter.

##### `dsc_isexported`

Data type: `Optional[Boolean]`

Returns true if the certificate file already exists and therefore has been exported.

##### `dsc_issuer`

Data type: `Optional[String]`

The issuer of the certificate to export. Certificate selector parameter.

##### `dsc_matchsource`

Data type: `Optional[Boolean]`

Causes an existing exported certificate to be compared with the certificate identified for export and re-exported if it does not match.

##### `dsc_protectto`

Data type: `Optional[Array[String]]`

Specifies an array of strings for the username or group name that can access the private key of an exported PFX file without any password.

##### `dsc_store`

Data type: `Optional[String]`

The Windows Certificate Store Name to search for the certificate to export from. Certificate selector parameter. Defaults to 'My'.

##### `dsc_subject`

Data type: `Optional[String]`

The subject of the certificate to export. Certificate selector parameter.

##### `dsc_thumbprint`

Data type: `Optional[String]`

The thumbprint of the certificate to export. Certificate selector parameter.

##### `dsc_type`

Data type: `Optional[Enum['Cert', 'cert', 'P7B', 'p7b', 'SST', 'sst', 'PFX', 'pfx']]`

Specifies the type of certificate to export.

#### Parameters

The following parameters are available in the `dsc_certificateexport` type.

* [`dsc_keyusage`](#-dsc_certificateexport--dsc_keyusage)
* [`dsc_password`](#-dsc_certificateexport--dsc_password)
* [`dsc_path`](#-dsc_certificateexport--dsc_path)
* [`dsc_psdscrunascredential`](#-dsc_certificateexport--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_certificateexport--dsc_timeout)
* [`name`](#-dsc_certificateexport--name)
* [`validation_mode`](#-dsc_certificateexport--validation_mode)

##### <a name="-dsc_certificateexport--dsc_keyusage"></a>`dsc_keyusage`

Data type: `Optional[Array[String]]`

The key usage of the certificate to export must contain these values. Certificate selector parameter.

##### <a name="-dsc_certificateexport--dsc_password"></a>`dsc_password`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Specifies the password used to protect an exported PFX file.

##### <a name="-dsc_certificateexport--dsc_path"></a>`dsc_path`

namevar

Data type: `String`

The path to the file you that will contain the exported certificate.

##### <a name="-dsc_certificateexport--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_certificateexport--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_certificateexport--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_certificateexport--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_certificateimport"></a>`dsc_certificateimport`

The DSC CertificateImport resource type.
Automatically generated from version 6.0.0

#### Properties

The following properties are available in the `dsc_certificateimport` type.

##### `dsc_content`

Data type: `Optional[String]`

The base64 encoded content of the CER file you want to import.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether the certificate should be present or absent.

##### `dsc_friendlyname`

Data type: `Optional[String]`

The friendly name of the certificate to set in the Windows Certificate Store.

##### `dsc_path`

Data type: `Optional[String]`

The path to the CER file you want to import.

#### Parameters

The following parameters are available in the `dsc_certificateimport` type.

* [`dsc_location`](#-dsc_certificateimport--dsc_location)
* [`dsc_psdscrunascredential`](#-dsc_certificateimport--dsc_psdscrunascredential)
* [`dsc_store`](#-dsc_certificateimport--dsc_store)
* [`dsc_thumbprint`](#-dsc_certificateimport--dsc_thumbprint)
* [`dsc_timeout`](#-dsc_certificateimport--dsc_timeout)
* [`name`](#-dsc_certificateimport--name)
* [`validation_mode`](#-dsc_certificateimport--validation_mode)

##### <a name="-dsc_certificateimport--dsc_location"></a>`dsc_location`

namevar

Data type: `Enum['LocalMachine', 'localmachine', 'CurrentUser', 'currentuser']`

The Windows Certificate Store Location to import the certificate to.

##### <a name="-dsc_certificateimport--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_certificateimport--dsc_store"></a>`dsc_store`

namevar

Data type: `String`

The Windows Certificate Store Name to import the certificate to.

##### <a name="-dsc_certificateimport--dsc_thumbprint"></a>`dsc_thumbprint`

namevar

Data type: `String`

The thumbprint (unique identifier) of the certificate you're importing.

##### <a name="-dsc_certificateimport--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_certificateimport--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_certificateimport--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_certreq"></a>`dsc_certreq`

The DSC CertReq resource type.
Automatically generated from version 6.0.0

#### Properties

The following properties are available in the `dsc_certreq` type.

##### `dsc_autorenew`

Data type: `Optional[Boolean]`

Determines if the resource will also renew a certificate within 7 days of expiration.

##### `dsc_carootname`

Data type: `Optional[String]`

The name of the certificate authority, by default this will be in format domain-servername-ca. Leave empty to automatically locate.

##### `dsc_caserverfqdn`

Data type: `Optional[String]`

The FQDN of the Active Directory Certificate Authority on the local area network. Leave empty to automatically locate.

##### `dsc_catype`

Data type: `Optional[String]`

The type of CA in use, Standalone/Enterprise.

##### `dsc_cepurl`

Data type: `Optional[String]`

The URL to the Certification Enrollment Policy Service.

##### `dsc_certificatetemplate`

Data type: `Optional[String]`

The template used for the definition of the certificate.

##### `dsc_cesurl`

Data type: `Optional[String]`

The URL to the Certification Enrollment Service.

##### `dsc_exportable`

Data type: `Optional[Boolean]`

The option to allow the certificate to be exportable, by default it will be true.

##### `dsc_keylength`

Data type: `Optional[Enum['192', '224', '256', '384', '521', '1024', '2048', '4096', '8192']]`

The bit length of the encryption key to be used. Defaults to 2048.

##### `dsc_keytype`

Data type: `Optional[Enum['RSA', 'rsa', 'ECDH', 'ecdh']]`

Specifies if the key type should be RSA or ECDH, defaults to RSA.

##### `dsc_providername`

Data type: `Optional[String]`

The selection of provider for the type of encryption to be used.

##### `dsc_requesttype`

Data type: `Optional[Enum['CMC', 'cmc', 'PKCS10', 'pkcs10']]`

Specifies if the request type should be CMC or PKCS10, deafults to CMC.

##### `dsc_subjectaltname`

Data type: `Optional[String]`

The subject alternative name used to create the certificate.

##### `dsc_usemachinecontext`

Data type: `Optional[Boolean]`

Indicates whether or not the flag -adminforcemachine will be used when requesting certificates. Necessary for certain templates like e.g. DomainControllerAuthentication

#### Parameters

The following parameters are available in the `dsc_certreq` type.

* [`dsc_credential`](#-dsc_certreq--dsc_credential)
* [`dsc_friendlyname`](#-dsc_certreq--dsc_friendlyname)
* [`dsc_keyusage`](#-dsc_certreq--dsc_keyusage)
* [`dsc_oid`](#-dsc_certreq--dsc_oid)
* [`dsc_psdscrunascredential`](#-dsc_certreq--dsc_psdscrunascredential)
* [`dsc_subject`](#-dsc_certreq--dsc_subject)
* [`dsc_timeout`](#-dsc_certreq--dsc_timeout)
* [`name`](#-dsc_certreq--name)
* [`validation_mode`](#-dsc_certreq--validation_mode)

##### <a name="-dsc_certreq--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The `PSCredential` object containing the credentials that will be used to access the template in the Certificate
Authority.

##### <a name="-dsc_certreq--dsc_friendlyname"></a>`dsc_friendlyname`

namevar

Data type: `String`

Specifies a friendly name for the certificate.

##### <a name="-dsc_certreq--dsc_keyusage"></a>`dsc_keyusage`

Data type: `Optional[String]`

The Keyusage is a restriction method that determines what a certificate can be used for.

##### <a name="-dsc_certreq--dsc_oid"></a>`dsc_oid`

Data type: `Optional[String]`

The Object Identifier that is used to name the object.

##### <a name="-dsc_certreq--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_certreq--dsc_subject"></a>`dsc_subject`

namevar

Data type: `String`

Provide the text string to use as the subject of the certificate.

##### <a name="-dsc_certreq--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_certreq--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_certreq--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_pfximport"></a>`dsc_pfximport`

The DSC PfxImport resource type.
Automatically generated from version 6.0.0

#### Properties

The following properties are available in the `dsc_pfximport` type.

##### `dsc_content`

Data type: `Optional[String]`

The base64 encoded content of the PFX file you want to import.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'present', 'Absent', 'absent']]`

Specifies whether the PFX file should be present or absent.

##### `dsc_exportable`

Data type: `Optional[Boolean]`

Determines whether the private key is exportable from the machine after it has been imported

##### `dsc_friendlyname`

Data type: `Optional[String]`

The friendly name of the certificate to set in the Windows Certificate Store.

##### `dsc_path`

Data type: `Optional[String]`

The path to the PFX file you want to import.

#### Parameters

The following parameters are available in the `dsc_pfximport` type.

* [`dsc_credential`](#-dsc_pfximport--dsc_credential)
* [`dsc_location`](#-dsc_pfximport--dsc_location)
* [`dsc_psdscrunascredential`](#-dsc_pfximport--dsc_psdscrunascredential)
* [`dsc_store`](#-dsc_pfximport--dsc_store)
* [`dsc_thumbprint`](#-dsc_pfximport--dsc_thumbprint)
* [`dsc_timeout`](#-dsc_pfximport--dsc_timeout)
* [`name`](#-dsc_pfximport--name)
* [`validation_mode`](#-dsc_pfximport--validation_mode)

##### <a name="-dsc_pfximport--dsc_credential"></a>`dsc_credential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

A `PSCredential` object that is used to decrypt the PFX file.

##### <a name="-dsc_pfximport--dsc_location"></a>`dsc_location`

namevar

Data type: `Enum['LocalMachine', 'localmachine', 'CurrentUser', 'currentuser']`

The Windows Certificate Store Location to import the PFX file to.

##### <a name="-dsc_pfximport--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_pfximport--dsc_store"></a>`dsc_store`

namevar

Data type: `String`

The Windows Certificate Store Name to import the PFX file to.

##### <a name="-dsc_pfximport--dsc_thumbprint"></a>`dsc_thumbprint`

namevar

Data type: `String`

The thumbprint (unique identifier) of the PFX file you're importing.

##### <a name="-dsc_pfximport--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_pfximport--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_pfximport--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_waitforcertificateservices"></a>`dsc_waitforcertificateservices`

The DSC WaitForCertificateServices resource type.
Automatically generated from version 6.0.0

#### Properties

The following properties are available in the `dsc_waitforcertificateservices` type.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

The number of times to loop the retry interval while waiting for the Active Directory Certificate Service Certificate Authority. Defaults to 60 retries.

##### `dsc_retryintervalseconds`

Data type: `Optional[Integer[0, 4294967295]]`

Specifies the number of seconds to wait for the Active Directory Certificate Service Certificate Authority to become available. Defaults to 10 seconds.

#### Parameters

The following parameters are available in the `dsc_waitforcertificateservices` type.

* [`dsc_carootname`](#-dsc_waitforcertificateservices--dsc_carootname)
* [`dsc_caserverfqdn`](#-dsc_waitforcertificateservices--dsc_caserverfqdn)
* [`dsc_psdscrunascredential`](#-dsc_waitforcertificateservices--dsc_psdscrunascredential)
* [`dsc_timeout`](#-dsc_waitforcertificateservices--dsc_timeout)
* [`name`](#-dsc_waitforcertificateservices--name)
* [`validation_mode`](#-dsc_waitforcertificateservices--validation_mode)

##### <a name="-dsc_waitforcertificateservices--dsc_carootname"></a>`dsc_carootname`

namevar

Data type: `String`

The name of the Active Directory Certificate Service Certificate Authority to wait for.

##### <a name="-dsc_waitforcertificateservices--dsc_caserverfqdn"></a>`dsc_caserverfqdn`

namevar

Data type: `String`

The FQDN of the Active Directory Certificate Service Certificate Authority to wait for.

##### <a name="-dsc_waitforcertificateservices--dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="-dsc_waitforcertificateservices--dsc_timeout"></a>`dsc_timeout`

Data type: `Optional[Integer]`

The maximum time in seconds to wait for the DSC resource to complete.

##### <a name="-dsc_waitforcertificateservices--name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="-dsc_waitforcertificateservices--validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

